<?
/**************************************************************************
 *  PHPRT - Action Item Tracking Tool                                     *
 *          (PHPRT.JS-X.com)                                              *
 *                                                                        *
 *  This program is free software: you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation, either version 3 of the License, or     *
 *  any later version.                                                    *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/


  include("config/global.inc.php");
  checkPermissions(1, $SESSION_TIMEOUT); // user logged in? - keep session alive...

  // non admins go bye-bye
  if(!$CURRENT_USER['IS_A_DB_ADMIN'] && !$CURRENT_USER['IS_A_PROJECT_ADMIN'])
  {
    redirect("index.php");
    exit;
  }

  $strProjectID = validateNumber($LA['pa-projectid'], $_FORM['txtProjectID'], 1, 1000000, FALSE);
  if($_FORM['btnSubmit']==$LA['pa-perform-action'] && ( $CURRENT_USER['IS_A_DB_ADMIN'] || $CURRENT_USER['PROJECT_ADMIN'][$strProjectID]))
  {
    $strUserID    = validateNumber($LA['pa-userid'],     $_FORM['txtUserID'], 1, 1000, TRUE);
    $strLevel     = validateNumber($LA['pa-access-level'],$_FORM['txtLevel'], 1, 1000, FALSE);

    if(!isset($strLevel) || $strLevel=="" || $strLevel==0)
    {
      $strSQL = "DELETE FROM $TABLE_PROJECT_ACCESS WHERE user_id='$strUserID' AND project_id='$strProjectID'";
      $result= dbquery($strSQL);
      $strError=$LA['pa-access-removed'];
    }

    if(!$strError)
    {
      $strSQL = "SELECT * FROM $TABLE_PROJECT_ACCESS WHERE user_id='$strUserID' AND project_id='$strProjectID'";
      $result= dbquery($strSQL);
      if($row= mysql_fetch_array($result))
      {
        ## if the project and user ids exist in this table -- update
        $strSQL1 = "UPDATE $TABLE_PROJECT_ACCESS SET";
        $strSQL1.= " project_id='$strProjectID'";
        $strSQL1.= ", user_id='$strUserID'";
        $strSQL1.= ", level='$strLevel' WHERE project_id='$strProjectID' AND user_id='$strUserID'";
        $result1 = dbquery($strSQL1);
        $strError = $LA['pa-access-updated'];
      }
      else
      {
        $strSQL1 = "INSERT INTO $TABLE_PROJECT_ACCESS SET";
        $strSQL1.= " project_id='$strProjectID'";
        $strSQL1.= ", user_id='$strUserID'";
        $strSQL1.= ", level='$strLevel'";
        $result1 = dbquery($strSQL1);
        $strError = $LA['pa-access-updated'];
      }
    }
  }
  else
  {
    $strProjectID = validateNumber($LA['pa-projectid'], $_FORM['txtProjectID'], 1, 1000000, FALSE);
    if(!$strProjectID)
    {
      // admin must select a project(id) to work with Items
      writeHeader($LA['pa-header']);
      declareError(TRUE);

      if($_FORM['searchSubmit'])
      {
        $TOP_SELECT ="<form class=forms name='form2' method='POST' onsubmit='return(document.form2.txtProjectID.selectedIndex>0);' action='".$_SERVER['PHP_SELF']."'>";
        $TOP_SELECT.="<br><table class=wrap cellpadding='0' cellspacing=0><tr><td>";
        $TOP_SELECT.="<table class=forms border='0' cellpadding='2'>";
        $TOP_SELECT.="<tr><td colspan=2 align=center>".$LA['pa-choose-project']."</td></tr>";
        $TOP_SELECT.="<tr> <td >Project:</td> <td ><select name='txtProjectID' class=forms>";
        $TOP_SELECT.="<option value=''>".$LA['pa-choose-project']."</option>\n";
        $BOT_SELECT.=" </select></td>\n </tr>\n";
        $BOT_SELECT.="<tr><td colspan=2 align=center>";
        $BOT_SELECT.="<input class=form_button type='submit' value='".$LA['pa-admin-users']."' name='searchSubmit'> ";
        $BOT_SELECT.="<input class=form_button type='reset' value='".$LA['pa-reset']."' name='reset'> ";
        $BOT_SELECT.="</td></tr></table>";
        $BOT_SELECT.="</td></tr></table>";
        $BOT_SELECT.=" </form>\n";

        $temp="";
        $temp2="";
        $temp3="";
        if(!$CURRENT_USER['IS_A_DB_ADMIN'])
        {
          $temp2=", $TABLE_PROJECT_ACCESS as A";
          $temp3=" AND A.project_id=P.project_id AND A.level>=".$PROJECT_ACCESS['admin'];
          $temp4=" WHERE A.user_id='".$CURRENT_USER['ID']."' AND A.project_id=P.project_id AND A.level>=".$PROJECT_ACCESS['admin'];
        }
        $strQ2 ="SELECT P.project_id,P.project_name from $TABLE_PROJECTS AS P $temp2 WHERE";
	/* for better security */
        $strName   = validateText($LA['pa-name'], $_FORM['txtName'], 1, 11, FALSE, FALSE);
        $strEmail  = validateText($LA['pa-email'], $_FORM['txtEmail'], 1, 11, FALSE, FALSE);
        $strAbbrev = validateText($LA['pa-abbrev'], $_FORM['txtAbbrev'], 1, 11, FALSE, FALSE);
        if(strlen($strName)  >1) { $strQ2.=" $temp P.project_name      like \"%".$strName."%\"";   $temp="AND"; }
        if(strlen($strEmail) >1) { $strQ2.=" $temp P.mail_alias        like \"%".$strEmail."%\"";  $temp="AND"; }
        if(strlen($strAbbrev)>1) { $strQ2.=" $temp P.project_abbr      like \"%".$strAbbrev."%\""; $temp="AND"; }
        if(!$temp) // we know we are looking for at least one attribute...
        {
          $strQ2="SELECT P.project_id,P.project_name FROM $TABLE_PROJECTS AS P $temp2 $temp4 ORDER BY project_name"; 
        }
        else
        {
          $strQ2.=" $temp3 ORDER BY project_name";
        }
          if($resultQ2=dbquery($strQ2))
          {
            print $TOP_SELECT;
            while($rowQ2=mysql_fetch_array($resultQ2))
            {
              print "<option value='".$rowQ2['project_id']."'>";
              print $rowQ2['project_name']." (".$rowQ2['project_id'].")";
              print "</option>\n";
            }
            print $BOT_SELECT;
        }
     }
    
?>
<form class=forms name="form1" method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<table cellpadding=0 cellspacing=0 class=wrap><tr><td>
  <br><table class=forms border='0' cellpadding='2'>
    <tr><td colspan=2 align=center><?=$LA['pa-search-msg'];?>:</td></tr>
    <tr>
      <td ><?=$LA['pa-proj-name'];?>:</td>
      <td ><input class=forms type="text" name="txtName" value="" size="40" maxlength="40"></td>
    </tr>
    <tr>
      <td ><?=$LA['pa-proj-abbrev'];?>:</td>
      <td ><input class=forms type="text" name="txtAbbrev" value="" size="10" maxlength="10"></td>
    </tr>
    <tr>
      <td ><?=$LA['pa-proj-email'];?>:</td>
      <td ><input class=forms type="text" name="txtEmail" value="" size="40" maxlength="50"></td>
    </tr>
    <tr><td colspan=2 align=center>
      <input class=form_button type="submit" value="<?=$LA['pa-search'];?>" name="searchSubmit">
      <input class=form_button type="reset" value="<?=$LA['pa-reset'];?>" name="reset">
    </td></tr></table>
  </td></tr></table>
</form>
<BR><BR>

<?
  print "<BR><BR>";
  writeFooter();
      exit;
    }
  }
  if($strProjectID && $strProjectID!=-1)
  {
    $strSQL2 = "SELECT * FROM $TABLE_PROJECTS WHERE project_id='$strProjectID'";
    $result2= dbquery($strSQL2);
    $row2= mysql_fetch_array($result2);

    $strName   = $row2['project_name'];
    $strAbbrev = $row2['project_abbr'];
  }

  writeHeader($LA['pa-edit-header']);
  declareError(TRUE);

if($strProjectID)
{
## if we get here - then the user has selected the Project to edit/delete/add User-Access ##

?>

<BR>
<form class=forms name="form1" method="POST" action="<?=$_SERVER['PHP_SELF'];?>">
<input type=hidden name="txtProjectID" value="<?=$strProjectID;?>">
<br>
<table class=forms border='0' cellpadding='2'>
    <tr>
      <td ><?=$LA['pa-proj-name'];?>: "<?=$strName;?>"</td>
      <td ><?=$LA['pa-project-alias'];?>: "<?=$strAbbrev;?>"</td>
    </tr>
</table>
<BR>
<table class=wrap border='0' cellpadding='2'>
<tr>
<td class=normal><?=$LA['pa-edit-acess'];?>:</td>
<td>
<select class=forms name="txtUserID">
<option value=""><?=$LA['pa-choose'];?></option>
<?
$strSQL = "SELECT A.user_id as UID,A.username,A.last_name,A.first_name,B.level FROM $TABLE_USERS AS A ";
$strSQL.= "LEFT JOIN $TABLE_PROJECT_ACCESS AS B ON A.user_id=B.user_id AND B.project_id='$strProjectID' ";
$strSQL.= " ORDER BY A.last_name";
$result= dbquery($strSQL);
while($row= mysql_fetch_array($result))
{
  $strLevel = $row['level'];
  $strFName = $row['first_name'];
  $strLName = $row['last_name'];
  $strUName = $row['username'];
  $strUserID= $row['UID'];
  $x=$REVERSE_PROJECT_ACCESS[$strLevel]?$REVERSE_PROJECT_ACCESS[$strLevel]:$REVERSE_PROJECT_ACCESS[''];
  echo "<option value='$strUserID'>$strLName, $strFName [$strUName] ($x)</option>\n";
}
?>
</select>
<select class=forms name="txtLevel">
<?
reset($PROJECT_ACCESS);
while(list($name,$value)=each($PROJECT_ACCESS))
{
 echo "<option value='$value'>$name</option>";
}
?>
</select>
</td>
</tr>
    <tr><td colspan=2 align=center>
      <input class=form_button type="submit" value="<?=$LA['pa-perform-action'];?>" name="btnSubmit">
      <input class=form_button type="reset" value="<?=$LA['pa-reset'];?>" name="reset">
    </td></tr>
</table>
<BR>
</form>

<?
}
  print "<BR><BR>";
  writeFooter();
?>
