<?
/**************************************************************************
 *  PHPRT - Action Item Tracking Tool                                     *
 *          (PHPRT.JS-X.com)                                              *
 *                                                                        *
 *  This program is free software: you can redistribute it and/or modify  *
 *  it under the terms of the GNU General Public License as published by  *
 *  the Free Software Foundation, either version 3 of the License, or     *
 *  any later version.                                                    *
 *                                                                        *
 *  This program is distributed in the hope that it will be useful,       *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *  GNU General Public License for more details.                          *
 *                                                                        *
 *  You should have received a copy of the GNU General Public License     *
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 **************************************************************************/

  @include("config/global.inc.php");

  if(isset($_FORM['activate']))
  {
    $strActivate = validateText("Code", $_FORM['activate'], 1, 80, TRUE, FALSE);
    //search for an account that has this code and is disabled.
    //then enable the account and remove the code from the db
    $strSQL = "SELECT U.user_id";
    $strSQL.= " FROM $TABLE_USERS AS U";
    $strSQL.= " WHERE U.activated_account='0' AND U.reactivate='$strActivate'";
    //echo "Q1:<DIR>$strSQL</DIR>\n";
    $result = dbquery($strSQL);
    if($row = mysql_fetch_array($result))
    {
      $strSQL2 = "UPDATE $TABLE_USERS";
      $strSQL2.= " SET activated_account='1', reactivate = NULL, succ_badpass='0'";
      $strSQL2.= " WHERE user_id = ".$row['user_id'];
      $result2 = dbquery($strSQL2);
      //echo "Q2:<DIR>$strSQL2</DIR>\n";
      $strError.="SUCCESS: Account is now active again.";
    }
  }
  else if (isset($_FORM['btnSubmit']))
  {
    $strUserName = validateText($LA['li-username'], $_FORM['txtUserName'], 3, 20, TRUE, FALSE);
    $strPassword = validateText($LA['li-password'], $_FORM['txtPassword'], 6, 10, TRUE, FALSE);

    if ($strError == "")
    {
        if($DEBUG){echo "strError-null(login)<BR>\n";}
        $strPassword = md5($strPassword);
        $strSQL1 = "SELECT U.num_logins, U.username, U.user_id, U.activated_account, U.db_admin, U.guest";
        $strSQL1.= " FROM $TABLE_USERS AS U";
        $strSQL1.= " WHERE U.username='$strUserName' AND U.password='$strPassword'";
        $result1 = dbquery($strSQL1);
        $row1 = mysql_fetch_array($result1);
	$IS_GUEST=isset($row['guest'])?$row['guest']:0;
        if ($row1['user_id'] && $row1['user_id'] != "" && $row1['activated_account'])
        {
            if($DEBUG){echo "user exists and account active(login)";}

            $_SESSION['userID']   = $row1['user_id'];
            $_SESSION['time']     = time();
            $_SESSION['dbAdmin']  = $row1['db_admin'];
            $_SESSION['security'] = 1;

            $num_logins=1+$row1['num_logins'];
            $strSQL2 = "UPDATE $TABLE_USERS";
            $strSQL2.= " SET num_logins='$num_logins', last_login=".date("U");
            $strSQL2.= " ,succ_badpass='0'";
            $strSQL2.= " WHERE user_id = '".$row1['user_id']."'";
            $result2 = dbquery($strSQL2);

            $strSQL2B ="INSERT INTO $TABLE_ACCESSTIMES (user_id,login,logout) VALUES ('".$_SESSION['userID']."',".date("U").",NULL)";
            $result2B = dbquery($strSQL2B);


	    /* check to see when a password times out - and then see if this password has expired.
	     * if it has - then generate a new one and email it to them... and tell them
	     */
             $strSQL1A = "SELECT A.pswd_exp_time, B.passworddate, B.email, B.guest";
             $strSQL1A.= " FROM $TABLE_USERS AS B";
             $strSQL1A.= " LEFT JOIN $TABLE_DB_INFO AS A ON A.pswd_exp_time > '0'";
             $strSQL1A.= " WHERE B.user_id='".$row1['user_id']."'";
	     //echo "Q:<DIR>$strSQL1A</DIR>";
             $result1A = dbquery($strSQL1A);
             $row1A = mysql_fetch_array($result1A);
	     $IS_GUEST=isset($row1A['guest'])?$row1A['guest']:0;
	     $pET=$row1A['pswd_exp_time'];  // stored as DAYS in DB
	     $pETS=$pET*60*60*24; // convert to seconds
	     $pUEX=$row1A['passworddate']; // time password was set
	     $pDelta=date("U")-$pUEX; // seconds since the EPOC - pUEX
	     $strEmail=$row1A['email'];
	     //echo "PD=$pDelta , pETS=$pETS<BR>\n";
	     /* only do this if it is not a guest account */
	     //echo "GUEST=$IS_GUEST=<BR>";
	     //echo "pET=$pET and pUEX=$pUEX and pDelta=$pDelta and pETS=$pETS<BR>\n";
	     // 10000            1120748875        990301  -- 36000000
	     // if $pET=0 then it is deactivated as a feature
	     if(!$IS_GUEST && $pET && ($pDelta>$pETS))
	     {
	       $strError= $LA['li-passexp-msg']."<BR><BR>";
	       $strError.= "<BR><BR>".$LA['li-to-continue']." - <a href='$PAGE_INDEX'>".$LA['li-click-here']."</a>.";
               $new_password="";
               $strTempString = "ABCDEFGHIJKLMNPQRSTUVWXYZ123456789";
               for ($i = 0; $i < 8; $i++)
               {
                 $intPos = rand(0, 33);
                 $strTempChar = substr($strTempString, $intPos, 1);
                 $new_password.=$strTempChar;
               }
	       $strSQLU ="UPDATE $TABLE_USERS SET";
	       $strSQLU.=" password='".md5($new_password)."'";
	       $strSQLU.=" , passworddate='".date(U)."'";
	       $strSQLU.=" WHERE user_id='".$row1['user_id']."'";
               $resultU = dbquery($strSQLU);

               $msgBody = $LA['li-passexp-new']."<BR>\n";
               $msgBody.= $LA['li-from'].": ".makeHomeURL()."<BR>\n";
               $msgBody.= $LA['li-username'].": $strUserName<BR>\n";
               $msgBody.= $LA['li-password'].": $new_password<BR>\n";
               if($strEmail)
               {
               mail($strEmail,$LA['li-passexp'].": ".date("m-d-Y"),$msgBody,$MAIL_HEADER);
               $strError.= "<BR>".$LA['li-pass-email']." $strEmail.";
               }
               else
               {
               mail($adminEmail,$LA['li-userexp'].": ".date("m-d-Y"),$msgBody,$MAIL_HEADER);
               $strError.= "<BR>".$LA['li-pass-email']." $adminEmail.";
               }
	       $LOGGED_IN=1;



	     }
	     //echo "DB-Timeout: ".$row1A['pswd_exp_time']."<BR>\n";
	     //echo " -- seconds --: ".(60*60*$row1A['pswd_exp_time'])."<BR>\n";
	     //echo "User-PW Date: ".$row1A['passworddate']."<BR>\n";
	     //echo "Now Date: ".date("U")."<BR>\n";
	     //echo "DELTA:".(date("U")-$row1A['passworddate'])."<BR>\n";
	     //exit;

            if (!$strError)
            {
                if(!$strRedir){$strRedir="index.php";}
                if($DEBUG)
                {
                  echo "UserID=".$_SESSION['userID']."<BR>\n";
                  echo "security=".$_SESSION['security']."<BR>\n";
                  echo "Redirect to: $strRedir<BR>\n";
                }
                header ("Location: $strRedir");
                exit;
            }
        }
        else
        {
            $strError="";
            $strSQL3 = "SELECT username, num_badpass, succ_badpass, activated_account, email, guest";
            $strSQL3.= " FROM $TABLE_USERS";
            $strSQL3.= " WHERE username='$strUserName'";
            $result3 = dbquery($strSQL3);
            $row3=mysql_fetch_array($result3);
	    $IS_GUEST=$row3['guest'];
            if($row3['username'] !="")
            {
              // User exists - just bad pass or account not activated.
              if(!$row3['activated_account'])
              {
                $reason="3"; // acount disabled
              }
              else
              {
                // $strError.="<BR>Bad Password\n";
                $reason="4A"; // bad password
                $succ_bad=1+$row3['succ_badpass'];
                $bad_pass=1+$row3['num_badpass'];
                $temp="";
		/* only if it is not a guest account */
                if(!$IS_GUEST && ($succ_bad>=$MAX_BAD_PASS))
                {
                  $reason="4B"; // bad password
                  $activateCode="";
                  $strTempString = "ABCDEFGHIJKLMNPQRSTUVWXYZ123456789";
                  for ($i = 0; $i < 10; $i++)
                  {
                    $intPos = rand(0, 33);
                    $strTempChar = substr($strTempString, $intPos, 1);
                    $activateCode.=$strTempChar;
                  }
		  $md5ActivateCode=md5($activateCode);
                  $temp=", activated_account='0', reactivate='$md5ActivateCode'";


$aLink=makeHomeURL()."/login.php?activate=".$md5ActivateCode; /* MAR JAN-3-09 fixed link */
$msgBody = $LA['li-disable1'];
$msgBody.= "<BR><a href='$aLink'>$aLink</a><BR><BR>";
$msgBody.= $LA['li-from'].": ".makeHomeURL()."<BR>\n";
$msgBody.= $LA['li-username'].": $strUserName<BR>\n"; /* MAR JAN-3-09 - fixed variable name */
$msgBody.= $LA['li-disable2']." $adminEmail.";

mail($row3['email'],$LA['li-email-dis'].": ".date("m-d-Y"),$msgBody,$MAIL_HEADER);
mail($adminEmail,$LA['li-user']." [$strUserName] ".$LA['li-accountdit'].": ".date("m-d-Y"),$msgBody,$MAIL_HEADER);

                }
                $strSQL4 ="UPDATE $TABLE_USERS";
                $strSQL4.= " SET succ_badpass='$succ_bad', last_badpass=".date("U");
                $strSQL4.= " ,num_badpass='$bad_pass' $temp";
                $strSQL4.= " WHERE username = '$strUserName'";
                $result4 = dbquery($strSQL4);
//echo "D:<DIR>".$strSQL4."</DIR>";
              }
            }
            else
            {
              $reason="5"; // username not valid
            }
            $strError = "You can not log in with that username/password. (0x3$reason)";
        }
    }
  }

  writeHeader("");

  if(!isset($strError))$strError="";
  switch ($strError) {
    case "timeout":
        $strError = ""; // clear
        fillError($LA['li-err1']);
        break;
    case "security":
        $strError = ""; // clear
        fillError($LA['li-err2']);
        $intNote = 1;
        break;
    case "login":
        $strError = ""; // clear
        fillError($LA['li-err3']);
        break;
    case "":
        $strError = "";
        break;
  }

  If ($strError != "") {
      echo $strError."<BR>\n";
  }
if(!isset($LOGGED_IN) || !$LOGGED_IN)
{
?>

<script>
function myLoad()
{
document.form1.txtUserName.focus();
}
onload=myLoad;
function pword()
{
  var _f=document.form1;
  if(_f.txtPassword1.value!='')
  {
    _f.txtPassword.value=_f.txtPassword1.value;
    _f.txtPassword1.value='';
  }
  return true;
}
</script>
<form name="form1" method="POST" action="login.php" onsubmit="pword(this.form)">
<input type=hidden name="txtPassword">
  <br><table align=center border='0' cellspacing=0 cellpadding=0>
    <tr>
      <td class=forms_login ><?=$LA['li-username'];?>:</td>
      <td class=forms_login width=10>&nbsp;</td>
      <td class=forms_login ><input class=forms_login type="text" name="txtUserName" value="<?echo isset($strUserName)?$strUserName:"";?>" size="20"></td>
    </tr>
    <tr>
      <td class=forms_login ><?=$LA['li-password'];?>:</td>
      <td class=forms_login width=10>&nbsp;</td>
      <td class=forms_login ><input class=forms_login type="password" name="txtPassword1" size="20"></td>
    </tr>
    <tr height=10><td colspan=3></td></tr>
    <tr>
      <td class=form_login colspan=3 align=center>
         <input type="hidden" name="strRedir" value="<?echo isset($strRedir)?$strRedir:"";?>">
         <input class=form_button type="submit" value="<?=$LA['li-submit'];?>" name="btnSubmit">
         <input class=form_button type="reset" value="<?=$LA['li-reset'];?>" name="reset">
      </td>
    </tr>
  </table><br>
  <?
       if(!isset($strRedir))$strRedir="";
       if(!isset($intNote))$intNote=0;
       If (!$strRedir OR $intNote) {
		   $strRedir = "http://".makeHomeURL("login.php")."/index.php";
       }
  ?>
</form>

<a href='forgotPW.php'><font size='-1'><?=$LA['li-forgot'];?></font></a>

<BR><BR>

<?
}
  writeFooter();
?>
